#!/usr/bin/perl
################
# ndert die Dateirechte
# 
# Dieser Quellcode darf durch den Arbeitskreis Linux am IFL Hamburg
# beliebig veraendert werden.
# Die Kopierrechte liegen bei dem Arbeitskreis Linux am IFL Hamburg.
# Es wird keine Haftung fuer entstehende Schaeden genommen.
#       Markus Zuehlke, Hamburg, 1998
#

$html_header = "<HTML><HEAD><TITLE>Dateirechte ver&auml;ndern</TITLE></HEAD>";
$html_noright = "<BODY BGCOLOR=#ff0000><H1>Zugang verweigert</H1></BODY></HTML>";

#

require '../../config.pl';
require '../../userdata.pl';
require '../../formdata.pl';
require './fm_access.pl';
require './dirsys.pl';

print "Content-type: text/html\n\n";
print "$html_header";

# Benutzerdaten auswerten ...
$USERNAME = $ENV{'REMOTE_USER'};
@USERDATA = getuserdata($USERNAME);

# Formdaten
%FORMDATA = hashFormData($ENV{'QUERY_STRING'});

# Benutzerrechte abpruefen
if (!getauth($USERDATA[7])) {
  print "$html_noright<!-- 1 -->";
  exit;
}

# Alte Dateiinformationen ermitteln ...
@fstats = stat($FORMDATA{'filename'});
if (@fstats == 0) {
  print "<BODY BGCOLOR=#0000ff><H1>Die Angegebene Datei existiert nicht!</H1></BODY></HTML>";
  exit;
}

# neue Gruppe und neuen Benutzer checken ...
$nuid = getuidbyuser($FORMDATA{'oname'});
$ngid = getgidbygroup($FORMDATA{'gname'});

if ($nuid == -1) {
  print "<BODY BGCOLOR=#0000ff><H1>Der angegebene Benutzer existiert nicht!</H1></BODY></HTML>";
  exit;
}
if ($ngid == -1) {
  print "<BODY BGCOLOR=#0000ff><H1>Die angegebene Gruppe existiert nicht!</H1></BODY></HTML>";
  exit;
}

# Duerfen die Rechte ueberhaupt geaendert werden ???
# Benutzerkontrolle
if ($USERDATA[7] != 1) {
  if ($USERDATA[7] != 2) {
    if ($USERDATA[7] != 3) {
      print $html_noright,"<!-- 2 -->";
      exit;
    } else {
      if (getuidbyuser($USERNAME) != $fstats[4]) {
        print $html_noright,"<!-- 3 -->";
        exit;
      }
    }
  } else {
    if ((getuserdata(getuserbyuid($fstats[4])))[11] ne $USERNAME) {
      if (getuidbyuser($USERNAME) != $fstats[4]) {
        print $html_noright,"<!-- 4 -->";
        exit;
      }
    }
  }
}
# fm_access.pl kontrolle
if (check_ac($FORMDATA{'filename'})!=0) {
  print $html_noright,"<!-- 5 -->";
  exit;
}
if (check_cm($FORMDATA{'filename'})!=0) {
  print $html_noright,"<!-- 6 -->";
  exit;
}

# chmod nummer erstellen
$chmodcode = 0;
if ($FORMDATA{'rur'} eq "on") {$chmodcode = $chmodcode + 256; }
if ($FORMDATA{'ruw'} eq "on") {$chmodcode = $chmodcode + 128; }
if ($FORMDATA{'rux'} eq "on") {$chmodcode = $chmodcode + 64; }
if ($FORMDATA{'rgr'} eq "on") {$chmodcode = $chmodcode + 32; }
if ($FORMDATA{'rgw'} eq "on") {$chmodcode = $chmodcode + 16; }
if ($FORMDATA{'rgx'} eq "on") {$chmodcode = $chmodcode + 8; }
if ($FORMDATA{'ror'} eq "on") {$chmodcode = $chmodcode + 4; }
if ($FORMDATA{'row'} eq "on") {$chmodcode = $chmodcode + 2; }
if ($FORMDATA{'rox'} eq "on") {$chmodcode = $chmodcode + 1; }

chmod $chmodcode, $FORMDATA{'filename'};
chown getuidbyuser($FORMDATA{'oname'}), getgidbygroup($FORMDATA{'gname'}), $FORMDATA{'filename'};

printf "<BODY BGCOLOR=#ffffff><H1>Die Rechte wurden ge&auml;ndert</H1><A HREF=\"listdir.cgi?directory=%s\">Verzeichnisansicht</A></BODY></HTML>",mkFormData($FORMDATA{'cudir'});
