###################
# Dieses Script gibt eine Dateiliste eines Verzeichnisses zurck
# Erstellt von Markus Zhlke 1998-06-08
#
# Dieser Quellcode darf durch den Arbeitskreis Linux am IFL Hamburg
# beliebig veraendert werden.
# Die Kopierrechte liegen bei dem Arbeitskreis Linux am IFL Hamburg.
# Es wird keine Haftung fuer entstehende Schaeden genommen.
#       Markus Zuehlke, Hamburg, 1998
#

sub getdirentries {
  my $dirname = $_[0];
  local @dires;
  
  opendir(DIRH, $dirname);
  @dires = readdir(DIRH);
  closedir(DIRH);
  
  return @dires;
}

# erstellt einen rwxrwxrwx String (ohne d)
sub makemodstring {
  my $fstatmod  = $_[0];
  local($res);
  
  if (($fstatmod & 256) == 256) {$res = "r";} else {$res = "-";}
  if (($fstatmod & 128) == 128) {$res = sprintf "%sw",$res;} else {$res = "$res-";}
  if (($fstatmod & 64) == 64){$res = sprintf "%sx",$res;} else {$res = "$res-";}
  if (($fstatmod & 32) == 32) {$res = sprintf "%sr",$res;} else {$res = "$res-";}
  if (($fstatmod & 16) == 16) {$res = sprintf "%sw",$res;} else {$res = "$res-";}
  if (($fstatmod & 8) == 8){$res = sprintf "%sx",$res;} else {$res = "$res-";}
  if (($fstatmod & 4) == 4) {$res = sprintf "%sr",$res;} else {$res = "$res-";}
  if (($fstatmod & 2) == 2) {$res = sprintf "%sw",$res;} else {$res = "$res-";}
  if (($fstatmod & 1) == 1){$res = sprintf "%sx",$res;} else {$res = "$res-";}
  return $res;
}

# Kontrolliert an Hand der fm_access.pl ob das Verzeichnis angezeigt werden
# soll, oder nicht.
# Rueckgabewerte: 0 = Verzeichnis soll angezeigt werden
#                 1 = Verzeichnis soll nicht angezeigt werden.
sub check_ac {
  my $filename = $_[0];
  local($sub_filename, $acc);
  
  $acc = $fm_deny_show;
  if ($fm_show_or_hide == 1) {
    foreach (@fm_show_dirs) {
      $sub_filename = substr($filename,0,length($_));
      if ($sub_filename eq $_) {
        $acc = 0;
      }
    }
    foreach (@fm_hide_dirs) {
      $sub_filename = substr($filename,0,length($_));
      if ($sub_filename eq $_) {
        $acc = 1;
      }
    }
  } else {
    foreach (@fm_hide_dirs) {
      $sub_filename = substr($filename,0,length($_));
      if ($sub_filename eq $_) {
        $acc = 1;
      }
    }
    foreach (@fm_show_dirs) {
      $sub_filename = substr($filename,0,length($_));
      if ($sub_filename eq $_) {
        $acc = 0;
      }
    }
  }
  return $acc;
}

# Trennt den Dateinamen von Verzeichnisnamen und gibt den Verzeichnisnamen
# zurueck.
sub getdirname {
  my $filedirname = $_[0];
  local ($tmp,$Zeichen);
  
  for ($tmp=length($filedirname)-1; $tmp>=0; $tmp--) {
    $Zeichen = substr($filedirname,$tmp,1);
    if ($Zeichen eq "/") {
      return substr($filedirname,0,$tmp+1);
    }
  }
  return "";
}

# Gibt 0 zurueck, wenn ein Benutzer im angegeben Verzeichnis Dateimodi ver-
# aendern darf.
sub check_cm {
  my $filename = $_[0];
  local($sub_filename, $acc);
  
  $sub_filename = getdirname($filename);
  $acc = $fm_deny_chmod;
  if ($fm_chmod_or_not == 1) {
    foreach (@fm_allow_chmod) {
      if ($sub_filename eq $_) {
        $acc = 0;
      }
    }
    foreach (@fm_no_chmod) {
      if ($sub_filename eq $_) {
        $acc = 1;
      }
    }
  } else {
    foreach (@fm_no_chmod) {
      if ($sub_filename eq $_) {
        $acc = 1;
      }
    }
    foreach (@fm_allow_chmod) {
      if ($sub_filename eq $_) {
        $acc = 0;
      }
    }
  }
  return $acc;
}
1; # Al
