#####################
# fm_access.pl
# Zugriffskonfigurationen fuer den Verzeichnisviewer
# Erstellt von Markus Zuehlke am 1998-07-04
# 

# Diese Datei enthaelt all die Verzeichnisse, die fuer die Benutzer nicht
# veraenderbar sein sollen, ect.

# Wenn $fm_deny_show auf 0 gesetzt ist, dann werden alle nicht definierten
# Verzeichnis angezeigt, und die Dateien dieser Verzeichnisse sind aenderbar.
# Anderfalls sind alle nicht definierten Verzeichnisse nicht sichtbar.
$fm_deny_show = 0;

# Wenn $fm_show_or_hide auf 1 steht, dann wird primaer ein Verzeichnis nicht
# angezeigt, Wenn die Variable auf 0 steht, dann wird ein Verzeichnis
# angezeigt. Wenn ein Verzeichnis sowohl im $fm_hide_dirs sowie im 
# $fm_show_dirs steht, dann wird es bei 1 nicht angezeigt und bei 0 angezeigt.
$fm_show_or_hide = 0;

# $fm_show_dirs[] sorgt dafuer, dass Verzeichnisse angezeigt werden. 
# Wenn ein Verzeichnis in der Liste ist, dann wird es angezeigt.
# Die Verzeichnisse werden rekursiv angezeigt.
@fm_show_dirs=('/home');

# $fm_hide_dirs[] sorgt dafuer, dass Verzeichnisse nicht angezeigt werden.
# Wenn ein Verzeichnis in der Liste steht, dann wird es nicht angezeigt. Die
# Verzeichnisse werden rekursiv nicht angezeigt.
@fm_hide_dirs=('/usr','/etc','/tmp','/lib','/dev','/proc','/bin','/sbin','/var','/lost+found','/boot');

# $fm_deny_chmod gibt an, ob Benutzer in nicht definierten Verzeichnisse
# chmod machen duerfen oder nicht. Wenn der Wert 1 ist, dann durefen Benutzer
# in nicht definierte Verzeichnisse den Dateimodi nicht veraendern.
$fm_deny_chmod = 0;

# $fm_chmod_or_not gibt an, ob primaer die Liste der Verzeichnisse gilt, in
# denen Dateimodi nicht geaendert werden duerfen(1), oder ob zuerst die
# Liste der Verzeichnisse in denen die Dateimodi geaendert werden duerfen
# gilt(0).
$fm_chmod_or_not = 0;

# $fm_no_chmod[] gibt die Verzeichnisse an, die zwar angezeigt werden sollen,
# in denen es aber nicht moeglich sein soll die Dateimodi zu aendern. 
# Diese Werte sind nicht rekursiv!!!
@fm_no_chmod=('/');

# $fm_allow_chmod[] gibt die Verzeichnisse an, in denen Dateimodi veraendert
# werden duerfen. Diese Werte gelten nicht rekursiv.
@fm_allow_chmod=();

# $fm_show_hidden_files gibt an, ob versteckte Dateien (Dateien die mit einem
# Punkt beginnen) angezeigt werden sollen oder nicht. Wenn 1, dann werden
# versteckte Dateien angezeigt.
$fm_show_hidden_files = 0;

1; 
